// DevForm.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "K01DASample.h"
#include "DevForm.h"
#include "TUSBKDA.h"
#include <math.h>
#define M_PI 3.14159265358979323846

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER1	1//Ď^C}[


/////////////////////////////////////////////////////////////////////////////
// CDevForm _CAO


CDevForm::CDevForm(CWnd* pParent /*=NULL*/)
	: CDialog(CDevForm::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevForm)
	m_IOSel0 = -1;
	m_IOSel1 = -1;
	m_ExtClock = 0;
	m_ClockSel = -1;
	m_IntClock = 0;
	m_DacData = 0.0;
	m_Ampl = 0.0;
	m_DataLeng = 0;
	m_WaveShape = -1;
	m_Offset = 0.0;
	//}}AFX_DATA_INIT
}


void CDevForm::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevForm)
	DDX_Control(pDX, IDC_DATA_LENG, m_DataLeng_Control);
	DDX_Control(pDX, IDC_OFFSET, m_Offset_Control);
	DDX_Control(pDX, IDC_AMPL, m_Ampl_Control);
	DDX_Control(pDX, IDC_WAVE_SHAPE, m_WaveShape_Control);
	DDX_Control(pDX, IDC_DAC_STOP, m_DacStop);
	DDX_Control(pDX, IDC_DAC_START, m_DacStart);
	DDX_Control(pDX, IDC_EXT_CLOCK_DISP, m_ExtClockDisp_Control);
	DDX_Control(pDX, IDC_INT_CLOCK_DISP, m_IntClockDisp_Control);
	DDX_Control(pDX, IDC_INT_CLOCK, m_IntClock_Control);
	DDX_Control(pDX, IDC_CLOCKSEL1, m_ClockSel_Control);
	DDX_Control(pDX, IDC_D1VIEW, m_D1View);
	DDX_Control(pDX, IDC_D0VIEW, m_D0View);
	DDX_Control(pDX, IDC_CLOCK_OUT, m_ClockOut_Control);
	DDX_Control(pDX, IDC_IOSEL1, m_IOSel1_Control);
	DDX_Control(pDX, IDC_IOSEL0, m_IOSel0_Control);
	DDX_CBIndex(pDX, IDC_IOSEL0, m_IOSel0);
	DDX_CBIndex(pDX, IDC_IOSEL1, m_IOSel1);
	DDX_Text(pDX, IDC_EXT_CLOCK, m_ExtClock);
	DDX_Radio(pDX, IDC_CLOCKSEL1, m_ClockSel);
	DDX_Text(pDX, IDC_INT_CLOCK, m_IntClock);
	DDX_Text(pDX, IDC_DAC_DATA, m_DacData);
	DDV_MinMaxDouble(pDX, m_DacData, -2.5, 2.5);
	DDX_Text(pDX, IDC_AMPL, m_Ampl);
	DDV_MinMaxDouble(pDX, m_Ampl, 0., 5.);
	DDX_Text(pDX, IDC_DATA_LENG, m_DataLeng);
	DDV_MinMaxInt(pDX, m_DataLeng, 1, 4096);
	DDX_CBIndex(pDX, IDC_WAVE_SHAPE, m_WaveShape);
	DDX_Text(pDX, IDC_OFFSET, m_Offset);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevForm, CDialog)
	//{{AFX_MSG_MAP(CDevForm)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_EXT_CLOCK, OnChangeExtClock)
	ON_EN_CHANGE(IDC_INT_CLOCK, OnChangeIntClock)
	ON_WM_CREATE()
	ON_CBN_SELCHANGE(IDC_IOSEL0, OnSelchangeIosel0)
	ON_CBN_SELCHANGE(IDC_IOSEL1, OnSelchangeIosel1)
	ON_BN_CLICKED(IDC_CLOCK_OUT, OnClockOut)
	ON_BN_CLICKED(IDC_CLOCKSEL1, OnClocksel1)
	ON_BN_CLICKED(IDC_CLOCKSEL2, OnClocksel2)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CONVERT, OnConvert)
	ON_BN_CLICKED(IDC_DAC_START, OnDacStart)
	ON_BN_CLICKED(IDC_DAC_STOP, OnDacStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevForm bZ[W nh

// This Form module initialize
void CDevForm::SetId(short Id)
{
	short retErr;
	char str[30];

	DevId = Id;

	UpdateData(TRUE);

	sprintf(str,"ID = %d  Panel",DevId);
	SendMessage(WM_SETTEXT,0,(LPARAM)str);
	retErr = TUSBK01DA_DIO_Status(DevId, IOStatus );
	if( retErr != 0 )
	{
		m_EtcFunc.ErrorDisp(NULL,retErr);
		ShowWindow(SW_HIDE);
	}
	else
	{
		m_IOSel0 = IOStatus[0];
		m_IOSel1 = IOStatus[1];
	}

	m_ExtClock = 1000;
	m_ClockSel = 1;
	m_WaveShape = 0;
	m_DataLeng = 1000;
	m_Ampl = 5.0;

	UpdateData(FALSE);
	OnChangeExtClock();
	OnChangeIntClock();

	EnableDisableCont(FALSE);
	SetTimer(TIMER1,100,NULL);
}

// timer handler
void CDevForm::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent )
	{
	case TIMER1:
		if( TUSBK01DA_Chk(DevId) != 0 )
		{
			ShowWindow(SW_HIDE);
			KillTimer(TIMER1);
		}
		else
		{
			DIO_Check();
		}
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

void CDevForm::DIO_Check()
{
	BYTE data;
	short retErr;

	retErr = TUSBK01DA_DIO_In(DevId, &data);
    
	if( retErr != 0 )
	{
		m_EtcFunc.ErrorDisp(NULL,retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
	}

	if( data & 0x01 )
		m_D0View.SetWindowText("High");
	else
		m_D0View.SetWindowText("Low");

	if( data & 0x02 )
		m_D1View.SetWindowText("High");
	else
		m_D1View.SetWindowText("Low");
}


// Ext Clock Value Check
void CDevForm::OnChangeExtClock() 
{
	UpdateData(TRUE);
	if( 1000 <= m_ExtClock && m_ExtClock <= 500000000 )
	{
		m_ExtClockDisp_Control.SetWindowText(
					m_EtcFunc.LongToCommaStr((long) TUSBK01DA_ExtTimer(m_ExtClock)));
	}
	else
	{
		m_ExtClockDisp_Control.SetWindowText("");
	}
}

// Check internal clock
void CDevForm::OnChangeIntClock() 
{
	UpdateData(TRUE);
	if( 50000 <= m_IntClock && m_IntClock <= 1000000000 )
	{
		m_IntClockDisp_Control.SetWindowText(
					m_EtcFunc.LongToCommaStr((long) TUSBK01DA_IntClk(m_IntClock)));
	}
	else
	{
		m_IntClockDisp_Control.SetWindowText("");
	}
}

int CDevForm::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_ExtClock = 1000;
	m_IntClock = 100000;
	m_ClockSel = 1;
	m_DataLeng = 1000;

	return 0;
}

// Digital Port Direction Change
void CDevForm::SetDir(char b)
{
	char dir;
	short retErr;

	if( IOStatus[b] != 0 )
		dir = 1;
	else
		dir = 0;
	
	retErr = TUSBK01DA_DIO_Dir(DevId, b, dir);

	if( retErr )
		m_EtcFunc.ErrorDisp(NULL,retErr);
}

// Digital Port Output Level
void CDevForm::SetDio(char b)
{
	char data;
	short retErr;

	if( IOStatus[b] == 2 )
		data = 1;
	else
		data = 0;

	retErr = TUSBK01DA_DIO_Out(DevId, b, data);

	if( retErr )
		m_EtcFunc.ErrorDisp(NULL,retErr);
}

//setup of Digital IO 0 state
void CDevForm::OnSelchangeIosel0() 
{
	UpdateData(TRUE);
	switch( m_IOSel0 )
	{
	case 0://INPUT
		IOStatus[0] = m_IOSel0;
		SetDir(0);
		break;
	case 1://LOW
		IOStatus[0] = m_IOSel0;
		SetDio(0);
		SetDir(0);
		break;
	case 2://HIGH
		IOStatus[0] = m_IOSel0;
		SetDio(0);
		SetDir(0);
	}
}

//setup of Digital IO 1 state
void CDevForm::OnSelchangeIosel1() 
{
	short retErr;

	UpdateData(TRUE);
	switch( m_IOSel1 )
	{
	case 0://INPUT
		IOStatus[1] = m_IOSel1;
		SetDir(1);
		break;
	case 1://LOW
		IOStatus[1] = m_IOSel1;
		SetDio(1);
		SetDir(1);
		break;
	case 2://HIGH
		IOStatus[1] = m_IOSel1;
		SetDio(1);
		SetDir(1);
	case 3://CLOCK
		retErr = TUSBK01DA_DIO_Status(DevId, IOStatus);
		if( retErr )
		{
			m_EtcFunc.ErrorDisp(NULL,retErr);
			KillTimer(TIMER1);
			ShowWindow(SW_HIDE);
		}
		else if( IOStatus[1] != 3 )
		{
			m_IOSel1 = IOStatus[1];
		}
	}
	UpdateData(FALSE);
}

// Ext Clock Out Command
void CDevForm::OnClockOut() 
{
	short retErr;

	UpdateData(TRUE);

	if( m_ExtClock < 1000 || m_ExtClock > 500000000 )
	{
		MessageBox("Cycle is outside the range.","ERROR",MB_OK);
	}
	else
	{
		retErr = TUSBK01DA_ExtTimer_Set(DevId,m_ExtClock);
		if( retErr )
			m_EtcFunc.ErrorDisp(NULL,retErr);
		else
		{
			m_IOSel1 = 3;
		}
	}
	UpdateData(FALSE);
}

// Enable Disable change of controls
void CDevForm::EnableDisableCont(char StartStop)
{
	if( StartStop )
	{
		m_DacStop.EnableWindow(TRUE);
		m_DacStart.EnableWindow(FALSE);
		m_ClockSel_Control.EnableWindow(FALSE);
		m_WaveShape_Control.EnableWindow(FALSE);
		m_Ampl_Control.EnableWindow(FALSE);
		m_Offset_Control.EnableWindow(FALSE);
		m_DataLeng_Control.EnableWindow(FALSE);
	}
	else
	{
		m_DacStop.EnableWindow(FALSE);
		m_DacStart.EnableWindow(TRUE);
		m_ClockSel_Control.EnableWindow(TRUE);
		m_WaveShape_Control.EnableWindow(TRUE);
		m_Ampl_Control.EnableWindow(TRUE);
		m_Offset_Control.EnableWindow(TRUE);
		m_DataLeng_Control.EnableWindow(TRUE);
	}
}

// When SelExtClock is checked
void CDevForm::OnClocksel1() 
{
	m_IntClock_Control.EnableWindow(FALSE);
}

// When SelIntClk is checked
void CDevForm::OnClocksel2() 
{
	m_IntClock_Control.EnableWindow(TRUE);
}

void CDevForm::OnClose() 
{
	KillTimer(TIMER1);

	CDialog::OnClose();
}

//DAC Digital -> Analog Convert
void CDevForm::OnConvert() 
{
	short retErr;
	short iDigit;

	UpdateData(TRUE);

	iDigit = (short) ( m_DacData / 2.5 * 8192.0 );//Convert Voltage -> Integer
	if( iDigit < -8192 )
		iDigit = -8192;
	else if( iDigit > 8191 )
		iDigit = 8191;

	retErr = TUSBK01DA_DacOut(DevId, iDigit);
	if( retErr )
		m_EtcFunc.ErrorDisp(NULL,retErr);
	if( m_DacStop.IsWindowEnabled() )
		EnableDisableCont(FALSE);
}

//Rectangle Generator
double CDevForm::RectangleF(double Arg)
{
	double tmpArg;
	double tmpD;

	//px10`1͈̔͂ɕϊ
	tmpArg = ( Arg / ( 2.0 * M_PI ) );//XP[2Pi->1ϊ
	tmpArg = modf(tmpArg,&tmpD);//͈͂-1`1ɕϊ(֐)
	if( tmpArg < 0 )//1炵Đɂ
		tmpArg += 1.0;

	if( tmpArg < 0.5 )
		return 1.0;
	else
		return -1.0;
}


//Triangle Generator
double CDevForm::TriangleF(double Arg)
{
	double tmpArg;
	double tmpD;

	//px10`1͈̔͂ɕϊ
	tmpArg = ( Arg / ( 2.0 * M_PI ) );//XP[2Pi->1ϊ
	tmpArg = modf(tmpArg,&tmpD);//͈͂-1`1ɕϊ(֐)
	if( tmpArg < 0 )//1炵Đɂ
		tmpArg += 1.0;

	if( tmpArg < 0.25 )//1/4܂
		return ( 4.0 * tmpArg );
	else if( tmpArg < 0.75 )//1/4`3/4܂
		return ( 4.0 * ( 0.5 - tmpArg ) );
	else///4`1܂
		return ( 4.0 * ( tmpArg - 1.0 ) );
}


void CDevForm::MakeShape(double *data, short shape, int leng, double amp, double offset)
{
	int cnt;

	switch( shape ){
	case 0://g
		for( cnt = 0 ; cnt < leng ; cnt++ )
			data[cnt] = amp * sin(2.0*M_PI*(double)cnt/(double)leng) + offset;
		break;
	case 1://Opg
		for( cnt = 0 ; cnt < leng ; cnt++ )
			data[cnt] = amp * TriangleF(2.0 * M_PI * (double)cnt / (double) leng) + offset;
		break;
	default://`g
		for( cnt = 0 ; cnt < leng ; cnt++ )
			data[cnt] = amp * RectangleF(2.0 * M_PI * (double)cnt / (double) leng) + offset;
		break;
	}
}

void CDevForm::OnDacStart() 
{
	double DataD[4096];
	short DataI[4096];
	int cnt;

	UpdateData(TRUE);

	//g`
	MakeShape(DataD, m_WaveShape, m_DataLeng , m_Ampl / 2.0, m_Offset);

	//(DACR[h)
    for( cnt = 0 ; cnt < m_DataLeng ; cnt++ )
	{
		DataD[cnt] = DataD[cnt] / 2.5 * 8192.0;
		DataI[cnt] = (short) DataD[cnt];
		if( DataI[cnt] >= 8191 )
			DataI[cnt] = 8191;
		else if( DataI[cnt] <= -8192 )
			DataI[cnt] = -8192;
	}

	//f[^ݒ
	TUSBK01DA_Data_Set(DevId, DataI, m_DataLeng);

	//Jn
	if( m_ClockSel == 0 )
		TUSBK01DA_Da_Start(DevId, 0, m_DataLeng);
	else
		TUSBK01DA_Da_Start(DevId, m_IntClock, m_DataLeng);

	EnableDisableCont(TRUE);
}

void CDevForm::OnDacStop() 
{
	short retErr;

	retErr = TUSBK01DA_Da_Stop(DevId);
    if( retErr )
		m_EtcFunc.ErrorDisp(NULL,retErr);
	EnableDisableCont(FALSE);
}
